
#define F_CPU 16000000
#define __PROG_TYPES_COMPAT__

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/io.h>
#include <util/delay.h>

#include "lcd.h"


#define BUZZER_PORT PORTD
#define BUZZER_DDR  DDRD
#define BUZZER_PIN  0


int number;
int letter;


int hourAlarm;
int minuteAlarm;


int inputNumber;
char inputLetter;

int choice;
int choose;

int calculResult;


volatile uint8_t hours = 0;
volatile uint8_t minutes = 0;
volatile uint8_t seconds = 0;


//function to activate buzzer
void BUZZ(float duration)
{
    int i;
 
 
    BUZZER_DDR = (1 << BUZZER_PIN) | BUZZER_DDR;  
 


    for (i=0;i<duration;i++)   
    {
        _delay_ms(25);                         
        BUZZER_PORT = (1 << BUZZER_PIN) | BUZZER_PORT;   
        _delay_ms(25);                         
        BUZZER_PORT = ~(1 << BUZZER_PIN) & BUZZER_PORT;   
    }
 
    return;     
}


//the buttons for column 4 and their result after press
void col4()
{
	//coloana C4
	PORTB =0b11111110;		


	if (!bit_is_set(PINB, 6))
	{
		//S12
		if (number == 1){
			inputNumber = 12;
			number = 0;
		}	

		if(letter == 1){
			inputLetter = 'R';
			letter = 0;
		}	
		BUZZ(50);
	}

	if (!bit_is_set(PINB, 7))
	{
		
		//S16
		if (number == 1){
			inputNumber = 0;
			number = 0;

		}	

		if(letter == 1){
			inputLetter = 'V';
			letter = 0;
		}	
		
		BUZZ(50);
		

	} 	

	if (!bit_is_set(PINB, 5))
	{
		//S8
		if (number == 1){
			inputNumber = 8;
			number = 0;
		}	

		if(letter == 1){
			inputLetter = 'L';
			letter = 0;
		}
		BUZZ(50);	
	}

	if (!bit_is_set(PINB, 4))
	{
		//S4
		if (number == 1){
			inputNumber = 4;
			number = 0;
		}	

		if(letter == 1){
			inputLetter = 'D';
			letter = 0;
		}
		BUZZ(50);	
	}
}

//the buttons for column 3 and their result after press
void col3()
{
	//coloana C3
	PORTB =0b11111101;		


	if (!bit_is_set(PINB, 6))
	{
		//S11
		if (number == 1){
			inputNumber = 11;
			number = 0;
		}		
		if(letter == 1){
			inputLetter = 'O';
			letter = 0;
		}
		BUZZ(50);
	}

	if (!bit_is_set(PINB, 7))
	{
		
		//S15

		if (number == 1){
			inputNumber = 15;
			number = 0;
		}	

		if(letter == 1){
			inputLetter = 'U';
			letter = 0;
		}
		BUZZ(50);	

	} 	

	if (!bit_is_set(PINB, 5))
	{
		//S7
		
		if (number == 1){
			inputNumber = 7;
			number = 0;
		}		

		if(letter == 1){
			inputLetter = 'I';
			letter = 0;
		}
		BUZZ(50);
	}

	if (!bit_is_set(PINB, 4))
	{
		//S3
		if (number == 1){
			inputNumber = 3;
			number = 0;
		}	

		if(letter == 1){
			inputLetter = 'C';
			letter = 0;
		}
		BUZZ(50);	
	}
}

//the buttons for column 1 and their result after press
void col1()
{
	//coloana C1
	PORTB =0b11110111;		


	if (!bit_is_set(PINB, 6))
	{
		//S9
		if (number == 1){
			inputNumber = 9;
			number = 0;
		}	

		if(letter == 1){
			inputLetter = 'M';
			letter = 0;
		}
		BUZZ(50);	
	}

	if (!bit_is_set(PINB, 7))
	{
		
		//S13

		if (number == 1){
			inputNumber = 13;
			number = 0;
		}		

		if(letter == 1){
			inputLetter = 'S';
			letter = 0;
		}
		BUZZ(50);
	} 	

	if (!bit_is_set(PINB, 5))
	{
		//S5
		if (number == 1){
			inputNumber = 5;
			number = 0;
		}		

		if(letter == 1){
			inputLetter = 'E';
			letter = 0;
		}
		BUZZ(50);
		
	}

	if (!bit_is_set(PINB, 4))
	{
		//S1
		if (number == 1){
			inputNumber = 1;
			number = 0;
		}	

		if(choose == 1){
			choice = 1;
			choose = 0;
		}

		if(letter == 1){
			inputLetter = 'A';
			letter = 0;
		}
		BUZZ(50);
	}
}

//the buttons for column 2 and their result after press
void col2()
{
	//coloana C2
	PORTB =0b11111011;		

	

	
	if (!bit_is_set(PINB, 6))
	{
		//S10
		if (number == 1){
			inputNumber = 10;
			number = 0;
		}
		if(letter == 1){
			inputLetter = 'N';
			letter = 0;
		}
		BUZZ(50);
		
	}

	if (!bit_is_set(PINB, 7))
	{
		
		//S14
		
		if (number == 1){
			inputNumber = 14;
			number = 0;
		}

		if(letter == 1){
			inputLetter = 'T';
			letter = 0;
		}
		BUZZ(50);
		

	} 	

	if (!bit_is_set(PINB, 5))
	{
		//S6
		if (number == 1){
			inputNumber = 6;
			number = 0;
		}

		if(letter == 1){
			inputLetter = 'F';
			letter = 0;
		}
		BUZZ(50);
	}

	if (!bit_is_set(PINB, 4))
	{
		//S2
		if (number == 1){
			inputNumber = 2;
			number = 0;
		}

		if(choose == 1){
			choice = 2;
			choose = 0;
		}

		if(letter == 1){
			inputLetter = 'B';
			letter = 0;
		}
		BUZZ(50);
		
	}
}


void intro()
{
	LCD_print("Istrate Lidia");
	LCD_printAt(LCD_INSTR_nextLine, "335CC");
	
	_delay_ms(2000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
}

void chooseCurrentHour()
{
	int count = 0;
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("Alege ora curenta");
	
		
	_delay_ms(800);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	number = 1;

	while(count < 4){
		//receive number input
		while(number == 1){
			col1();
			col2();
			col3();
			col4();
		}

		if(count == 0){
			hours = hours + inputNumber * 10;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		} else if(count == 1){
			hours = hours + inputNumber;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		} else if(count == 2){
			LCD_putChar(':');
			minutes = minutes + inputNumber * 10;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		} else if(count == 3){
			minutes = minutes + inputNumber;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		}

		
	}
	
	number = 0;


}




void chooseAlarmHour()
{
	int count = 0;
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("Alege ora alarma");
	
		
	_delay_ms(800);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	number = 1;

	while(count < 4){
		//receive number input
		while(number == 1){
			col1();
			col2();
			col3();
			col4();
		}

		if(count == 0){
			hourAlarm = hourAlarm + inputNumber * 10;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		} else if(count == 1){
			hourAlarm = hourAlarm + inputNumber;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		} else if(count == 2){
			LCD_putChar(':');
			minuteAlarm = minuteAlarm + inputNumber * 10;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		} else if(count == 3){
			minuteAlarm = minuteAlarm + inputNumber;
			count++;
			number = 1;
			LCD_putChar(inputNumber + '0');
		}

		
	}
	
	number = 0;


}





void gameChoice()
{
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("Alege intre");
	_delay_ms(4000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("Calcul 1");
	LCD_printAt(LCD_INSTR_nextLine, "Hangman 2");
	
	_delay_ms(6000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
}




void calcul(){

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("2*5=");
	number = 1;
	int result = 0;

	while(inputNumber != 15){

		while(number == 1){
			col1();
			col2();
			col3();
			col4();
		}
		if(inputNumber == 15){
			break;
		}

		LCD_putChar(inputNumber + '0');
		result = result * 10 + inputNumber;
		number = 1;
	}

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	if (result == 10) {
		LCD_print("Corect :)");
	} else {
		LCD_print("Gresit :(");
	}	
}




void hangman() {

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_printAt(0x00, "Ghiceste cuvantul!");
	_delay_ms(2000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);

	int i = 0;
	inputLetter = ' ';


	char *word = "VACANTA";
	int wordSize = 7;

	for (i = 0; i < wordSize; i++)
		LCD_printAt(0x00 + i, "_");

	int lives = 5;
	int foundLetters = 0;
	int prevFind = 0;

	//the alphabet (limited edition)
	char alphabet[16]={'A','B','C','D','E','F','I','L','M','N','O','R','S','T','U','V'};
	

	while(1) {

		//receive letter input
		while(letter == 1){
			col1();
			col2();
			col3();
			col4();
		}
		prevFind = foundLetters;

		for (i = 0; i < wordSize; i++){
			if(word[i] == inputLetter){
				LCD_putCharAt(0x00 + i, inputLetter);
				word[i] = '*';
				foundLetters++;
			}
		}
		
		

		if(foundLetters == prevFind){
			lives--;
		}

		if(foundLetters == wordSize){
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(0x00, "Corect :)");
			_delay_ms(2000);
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			break;
		}

		if(lives == 0){
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(0x00, "Gresit :(");
			_delay_ms(2000);
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			break;
		}


		letter = 1;


	}


}



//update current time
ISR(TIMER2_COMPA_vect)
{
	static uint16_t miliseconds = 0;

	if(++miliseconds != 1000)
		return;
	miliseconds = 0;

	if(++seconds == 60)
	{
		seconds = 0;

		if(++minutes == 60)
		{
			minutes = 0;

			if(++hours == 24)
				hours = 0;
		}
	}

	char buf[9];
	snprintf(buf, sizeof(buf), "%02d:%02d:%02d", hours, minutes, seconds);

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_printAt(0x00, buf);
}

void timer2_init(void)
{
	// set compare at each milisecond
	OCR2A = 124;
	// interrupt on compare A
	TIMSK2 |= (1 << OCIE2A);
	// CTC, top OCRA
	TCCR2A |= (1 << WGM21);
	// prescaler 128
	TCCR2B |= (1 << CS20) | (1 << CS22);
}


void timer2_stop(void)
{
	TCCR2B = 0;
	TCCR2A = 0;
	OCR2A = 0;
	TIMSK2 = 0;
}




int main() 
{	
	LCD_init();


	
	DDRD |= 1 << PD7;


	number = 0;
	letter = 0;

	hourAlarm = 0;
	minuteAlarm = 0;

	inputNumber = 0;
	choose = 0;
	choice = 0;

	DDRB=0x0F;
	PORTB=0xF0;

	intro();

	chooseCurrentHour();

	chooseAlarmHour();

	//start counting until the alarm hour
	timer2_init();

	sei();

	while (1) {
		

		_delay_ms(300);
		

		if(hours == hourAlarm && minutes == minuteAlarm){
			BUZZ(100);
			break;
		}

	}	


	timer2_stop();


	//for the buttons matrix
	DDRB=0x0F;
	PORTB=0xF0;

	choose = 1;

	//choose a game
	gameChoice();


	while(choose == 1) {
		col1();
		col2();
		col3();
		col4();
	}

	if(choice == 1){
		LCD_print("Calcul");
		_delay_ms(2000);
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		calcul();
	} else if(choice == 2){
		LCD_print("Hangman");
		_delay_ms(2000);
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		hangman();
	} else  {
		LCD_print("Inexistent");
		_delay_ms(2000);
		LCD_writeInstr(LCD_INSTR_clearDisplay);
	}


	return 0;
}
